# Backend Sigma

Ce dépôt contient le _backend_ de Sigma, le successeur de Frankiz.

Pour obtenir une copie de ce dépôt, clonez-le avec

    git clone git@gitlab.binets.fr/br/sigma-backend

puis installez les dépendences JavaScript avec

    npm install

## Dépendances

Il y a deux types de dépendances : les dépendances _normales_ (pour que le serveur tourne en prod grosso modo), et les dépendances dév, qui servent à tester par exemple. Pour avoir la liste des dépendances, allez lire le fichier `package.json`. Express est un exemple de dépendance normale, nodemon et ESLint (voir infra) sont des dépendances dev.

## Structure

Les fichiers source se situent dans le dossier `src`.

Pour l'instant, le serveur utilisé est [express.js](https://expressjs.com/), le code est dans `server.js`. Le point d'entrée de l'application est `index.js`.

Pour le faire tourner en mode normal, utilisez `npm start` ou de façon équivalente `node src/index.js`.

Pour le faire tourner en test, `npm test` démarre [nodemon](https://nodemon.io/), qui démarre le serveur dans `index.js` et le redémarre automatiquement quand vous modifiez un fichier.

## ESLint

On utilisera ESLint pour standardiser le code : un ensemble de règles de style pour le code sont appliquées, et quelques-unes d'entre elles sont dans le fichier `.eslintrc.json`. Pour l'instant, la config ESLint impose d'utiliser quatre espaces pour les indentations et de ne pas utiliser de point-virgule en fin de ligne.

Pour faire valider un fichier `file.js` par ESLint, utilisez

    npm eslint file.js

Sinon, si vous utilisez Atom ou Visual Studio Code pour éditer votre code, il existe des plugins qui font tourner ESLint en _live_ sur le code et vérifient que tout est en ordre.

Pour mieux comprendre ESLint, référez-vous à la [doc](https://eslint.org/docs/user-guide/getting-started).
